Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 15032)
@@ -15,5 +15,10 @@
   /// </summary>
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.IF", StackTypes.Boolean, execIn: 2)]
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.IF",
+    "If the top item of the BOOLEAN stack is TRUE then this removes the second item on the EXEC stack, leaving the first item to be executed. If it is false then it removes the first item, leaving the second to be executed.",
+    StackTypes.Boolean,
+    execIn: 2)]
   public class ExecIfExpression : StatelessExpression {
     public ExecIfExpression() { }
@@ -34,8 +39,11 @@
 
   /// <summary>
-  ///     Inserts beneath the top item of the EXEC stack a new item of the form
-  ///     "( EXEC.Y <TopItem> )".
-  /// </summary>
-  [PushExpression(StackTypes.Exec, "EXEC.Y", execIn: 1)]
+  /// Inserts beneath the top item of the EXEC stack a new item of the form "( EXEC.Y <TopItem> )".
+  /// </summary>
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.Y",
+    "Inserts beneath the top item of the EXEC stack a new item of the form \"( EXEC.Y <TopItem> )\"",
+    execIn: 1)]
   [StorableClass]
   public class ExecYExpression : StatelessExpression {
@@ -66,7 +74,11 @@
 
   /// <summary>
-  ///     Removes the second item on the EXEC stack.
-  /// </summary>
-  [PushExpression(StackTypes.Exec, "EXEC.K", execIn: 2)]
+  /// Removes the second item on the EXEC stack.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.K",
+    "Removes the second item on the EXEC stack.",
+    execIn: 2)]
   [StorableClass]
   public class ExecKExpression : StatelessExpression {
@@ -86,9 +98,13 @@
 
   /// <summary>
-  ///     Pops 3 items from the EXEC stack, which we will call A, B, and C
-  ///     (with A being the first one popped). Then pushes a list containing B and C back onto the EXEC stack, followed by
-  ///     another instance of C, followed by another instance of A.
-  /// </summary>
-  [PushExpression(StackTypes.Exec, "EXEC.S", execIn: 3)]
+  /// Pops 3 items from the EXEC stack, which we will call A, B, and C
+  /// (with A being the first one popped). Then pushes a list containing B and C back onto the EXEC stack, followed by
+  /// another instance of C, followed by another instance of A.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.S",
+    "Pops 3 items from the EXEC stack called A, B, and C. Then pushes a list containing B and C back onto the EXEC stack, followed by another instance of C, followed by another instance of A.",
+    execIn: 3)]
   [StorableClass]
   public class ExecSExpression : StatelessExpression {
@@ -121,10 +137,13 @@
 
   /// <summary>
-  ///     Does nothing.
+  /// Does nothing.
   /// </summary>
   ///
   [StorableClass]
   [Serializable]
-  [PushExpression(StackTypes.Exec, "EXEC.NOOP")]
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.NOOP",
+    "Does nothing.")]
   public class ExecNoopExpression : StatelessExpression {
     public ExecNoopExpression() { }
@@ -141,5 +160,12 @@
   }
 
-  [PushExpression(StackTypes.Exec, "EXEC.WHILE", StackTypes.Boolean, execIn: 1)]
+  /// <summary>
+  /// Executes top EXEC item recursively as long top BOOLEAN is TRUE.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.WHILE",
+    "Executes top EXEC item recursively as long top BOOLEAN is TRUE.",
+    StackTypes.Boolean, execIn: 1)]
   [StorableClass]
   public class ExecWhileExpression : StatelessExpression {
@@ -153,21 +179,22 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      if (interpreter.BooleanStack.IsEmpty) {
+      if (interpreter.BooleanStack.IsEmpty ||
+          !interpreter.BooleanStack.Pop()) {
         interpreter.ExecStack.Pop();
         return;
       }
 
-      var booleanTop = interpreter.BooleanStack.Pop();
-
-      if (!booleanTop) {
-        interpreter.ExecStack.Pop();
-        return;
-      }
-
       interpreter.ExecStack.Push(this, interpreter.ExecStack.Top);
     }
   }
 
-  [PushExpression(StackTypes.Exec, "EXEC.DO*WHILE", execIn: 1)]
+  /// <summary>
+  /// Executes top EXEC item recursively until max. amount of eval. expressions is reached or top EXEC item removes the the recursive call.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.DO*WHILE",
+    "Executes top EXEC item recursively until max. amount of eval. expressions is reached or top EXEC item removes the the recursive call.",
+    execIn: 1)]
   [StorableClass]
   public class ExecDoWhileExpression : StatelessExpression {
@@ -185,5 +212,13 @@
   }
 
-  [PushExpression(StackTypes.Exec, "EXEC.WHEN", StackTypes.Boolean, execIn: 1)]
+  /// <summary>
+  /// Top EXEC item is only executed, if top BOOLEAN is TRUE.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.WHEN",
+    "Top EXEC item is only executed, if top BOOLEAN is TRUE.",
+    StackTypes.Boolean,
+    execIn: 1)]
   [StorableClass]
   public class ExecWhenExpression : StatelessExpression {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 15032)
@@ -60,7 +60,7 @@
         if (attribute.IsHidden) continue;
 
-        indexToNameTable.Add(indexToNameTable.Keys.Count, attribute.ExpressionName);
-        typeToNameTable.Add(type, attribute.ExpressionName);
-        nameToTypeTable.Add(attribute.ExpressionName, type);
+        indexToNameTable.Add(indexToNameTable.Keys.Count, attribute.Name);
+        typeToNameTable.Add(type, attribute.Name);
+        nameToTypeTable.Add(attribute.Name, type);
 
         if (!stackTypeToNamesTable.ContainsKey(attribute.StackType)) {
@@ -68,5 +68,5 @@
         }
 
-        stackTypeToNamesTable[attribute.StackType].Add(attribute.ExpressionName);
+        stackTypeToNamesTable[attribute.StackType].Add(attribute.Name);
 
         var dependencies = attribute.StackType | attribute.AdditionalStackDependencies;
@@ -75,5 +75,5 @@
         }
 
-        stackDependencyToNamesTable[dependencies].Add(attribute.ExpressionName);
+        stackDependencyToNamesTable[dependencies].Add(attribute.Name);
       }
 
@@ -98,7 +98,7 @@
         if (attribute.IsHidden) continue;
 
-        indexToNameTable.Add(indexToNameTable.Keys.Count, attribute.ExpressionName);
-        typeToNameTable.Add(type, attribute.ExpressionName);
-        nameToTypeTable.Add(attribute.ExpressionName, type);
+        indexToNameTable.Add(indexToNameTable.Keys.Count, attribute.Name);
+        typeToNameTable.Add(type, attribute.Name);
+        nameToTypeTable.Add(attribute.Name, type);
 
         if (!stackTypeToNamesTable.ContainsKey(attribute.StackType)) {
@@ -106,5 +106,5 @@
         }
 
-        stackTypeToNamesTable[attribute.StackType].Add(attribute.ExpressionName);
+        stackTypeToNamesTable[attribute.StackType].Add(attribute.Name);
 
         var dependencies = attribute.StackType | attribute.AdditionalStackDependencies;
@@ -113,5 +113,5 @@
         }
 
-        stackDependencyToNamesTable[dependencies].Add(attribute.ExpressionName);
+        stackDependencyToNamesTable[dependencies].Add(attribute.Name);
       }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 15032)
@@ -11,7 +11,10 @@
 
   /// <summary>
-  ///     Pushes the sum of the top two items.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.+")]
+  /// Pushes the sum of the top two items.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.+",
+    "Pushes the sum of the top two items.")]
   [StorableClass]
   public class FloatAddExpression : StatelessExpression {
@@ -37,7 +40,10 @@
 
   /// <summary>
-  ///     Pushes the difference of the top two items; that is, the second item minus the top item.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.-")]
+  /// Pushes the difference of the top two items; that is, the second item minus the top item.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.-",
+    "Pushes the difference of the top two items; that is, the second item minus the top item.")]
   [StorableClass]
   public class FloatSubtractExpression : StatelessExpression {
@@ -63,7 +69,10 @@
 
   /// <summary>
-  ///     Pushes the product of the top two items.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.*")]
+  /// Pushes the product of the top two items.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.*",
+    "Pushes the product of the top two items.")]
   [StorableClass]
   public class FloatMultiplyExpression : StatelessExpression {
@@ -89,8 +98,11 @@
 
   /// <summary>
-  ///     Pushes the quotient of the top two items; that is, the second item divided by the top item.
-  ///     If the top item is zero this acts as a NOOP.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT./")]
+  /// Pushes the quotient of the top two items; that is, the second item divided by the top item.
+  /// If the top item is zero this acts as a NOOP.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT./",
+    "Pushes the quotient of the top two items; that is, the second item divided by the top item. If the top item is zero this acts as a NOOP.")]
   [StorableClass]
   public class FloatDivideExpression : StatelessExpression {
@@ -116,11 +128,10 @@
 
   /// <summary>
-  ///     Pushes the second stack item modulo the top stack item. If the top item is zero this acts as a NOOP.
-  ///     The modulus is computed as the remainder of the quotient, where the quotient has first been truncated toward
-  ///     negative infinity.
-  ///     (This is taken from the definition for the generic MOD function in Common Lisp, which is described
-  ///     for example at http://www.lispworks.com/reference/HyperSpec/Body/f_mod_r.htm.)
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.%")]
+  /// Pushes the second stack item modulo the top stack item. If the top item is zero this acts as a NOOP.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.%",
+    "Pushes the second stack item modulo the top stack item. If the top item is zero this acts as a NOOP.")]
   [StorableClass]
   public class FloatModuloExpression : StatelessExpression {
@@ -143,7 +154,10 @@
 
   /// <summary>
-  ///     Pushes the minimum of the top two items.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.MIN")]
+  /// Pushes the minimum of the top two items.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.MIN",
+    "Pushes the minimum of the top two items.")]
   [StorableClass]
   public class FloatMinExpression : StatelessExpression {
@@ -166,7 +180,10 @@
 
   /// <summary>
-  ///     Pushes the maximum of the top two items.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.MAX")]
+  /// Pushes the maximum of the top two items.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.MAX",
+    "Pushes the maximum of the top two items.")]
   [StorableClass]
   public class FloatMaxExpression : StatelessExpression {
@@ -189,7 +206,11 @@
 
   /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.<", StackTypes.Boolean)]
+  /// Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.<",
+    "Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class FloatSmallerThanExpression : StatelessExpression {
@@ -213,7 +234,11 @@
 
   /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.<=", StackTypes.Boolean)]
+  /// Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.<=",
+    "Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class FloatSmallerThanOrEqualExpression : StatelessExpression {
@@ -237,7 +262,11 @@
 
   /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.>", StackTypes.Boolean)]
+  /// Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.>",
+    "Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class FloatGreaterThanExpression : StatelessExpression {
@@ -261,7 +290,11 @@
 
   /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than or equal to the top item, or FALSE otherwise.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.>=", StackTypes.Boolean)]
+  /// Pushes TRUE onto the BOOLEAN stack if the second item is greater than or equal to the top item, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.>=",
+    "Pushes TRUE onto the BOOLEAN stack if the second item is greater than or equal to the top item, or FALSE otherwise.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class FloatGreaterThanOrEqualExpression : StatelessExpression {
@@ -285,7 +318,7 @@
 
   /// <summary>
-  ///     Pushes the sine of the top item.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.SIN")]
+  /// Pushes the sine of the top item.
+  /// </summary>
+  [PushExpression(StackTypes.Float, "FLOAT.SIN", "Pushes the sine of the top item.")]
   [StorableClass]
   public class FloatSineExpression : StatelessExpression {
@@ -305,7 +338,7 @@
 
   /// <summary>
-  ///     Pushes the cosine of the top item.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.COS")]
+  /// Pushes the cosine of the top item.
+  /// </summary>
+  [PushExpression(StackTypes.Float, "FLOAT.COS", "Pushes the cosine of the top item.")]
   public class FloatCosineExpression : StatelessExpression {
     public FloatCosineExpression() { }
@@ -324,7 +357,11 @@
 
   /// <summary>
-  ///     Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.FROMBOOLEAN", StackTypes.Boolean)]
+  /// Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.FROMBOOLEAN",
+    "Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class FloatFromBooleanExpression : StatelessExpression {
@@ -346,7 +383,11 @@
 
   /// <summary>
-  ///     Pushes a floating point version of the top INTEGER.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.FROMINTEGER", StackTypes.Integer)]
+  /// Pushes a floating point version of the top INTEGER.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.FROMINTEGER",
+    "Pushes a floating point version of the top INTEGER.",
+    StackTypes.Integer)]
   [StorableClass]
   public class FloatFromIntegerExpression : StatelessExpression {
@@ -366,7 +407,11 @@
 
   /// <summary>
-  ///     Pushes the result of truncating the top CHAR.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.FROMCHAR", StackTypes.Char)]
+  /// Pushes the result of truncating the top CHAR.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.FROMCHAR",
+    "Pushes the result of truncating the top CHAR.",
+    StackTypes.Char)]
   [StorableClass]
   public class FloatFromCharExpression : StatelessExpression {
@@ -386,7 +431,11 @@
 
   /// <summary>
-  ///     Pushes the result of parsing the top STRING.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.FROMSTRING", StackTypes.String)]
+  /// Pushes the result of parsing the top STRING.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.FROMSTRING",
+    "Pushes the result of parsing the top STRING.",
+    StackTypes.String)]
   [StorableClass]
   public class FloatFromStringExpression : StatelessExpression {
@@ -411,7 +460,10 @@
 
   /// <summary>
-  ///     Pushes the result of increasing the top INTEGER by 1.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.INC")]
+  /// Pushes the result of increasing the top INTEGER by 1.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.INC",
+    "Pushes the result of increasing the top INTEGER by 1.")]
   [StorableClass]
   public class FloatIncExpression : StatelessExpression {
@@ -430,7 +482,10 @@
 
   /// <summary>
-  ///     Pushes the result of decreasing the top INTEGER by 1.
-  /// </summary>
-  [PushExpression(StackTypes.Float, "FLOAT.DEC")]
+  /// Pushes the result of decreasing the top INTEGER by 1.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.DEC",
+    "Pushes the result of decreasing the top INTEGER by 1.")]
   [StorableClass]
   public class FloatDecExpression : StatelessExpression {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs	(revision 15032)
@@ -9,5 +9,5 @@
 
   /// <summary>
-  ///     Empties the given stack.
+  /// Empties the given stack.
   /// </summary>
   /// <typeparam name="T">Stacktype</typeparam>
@@ -23,5 +23,8 @@
   }
 
-  [PushExpression(StackTypes.Integer, "INTEGER.FLUSH")]
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.FLUSH",
+    "Empties the INTEGER stack.")]
   [StorableClass]
   public class IntegerFlushExpression : FlushExpression<long> {
@@ -39,5 +42,8 @@
   }
 
-  [PushExpression(StackTypes.Float, "FLOAT.FLUSH")]
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.FLUSH",
+    "Empties the FLOAT stack.")]
   [StorableClass]
   public class FloatFlushExpression : FlushExpression<double> {
@@ -55,5 +61,8 @@
   }
 
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.FLUSH")]
+  [PushExpression(
+    StackTypes.Boolean,
+    "BOOLEAN.FLUSH",
+    "Empties the BOOLEAN stack.")]
   [StorableClass]
   public class BooleanFlushExpression : FlushExpression<bool> {
@@ -71,5 +80,8 @@
   }
 
-  [PushExpression(StackTypes.Name, "NAME.FLUSH")]
+  [PushExpression(
+    StackTypes.Name,
+    "NAME.FLUSH",
+    "Empties the NAME stack.")]
   [StorableClass]
   public class NameFlushExpression : FlushExpression<string> {
@@ -87,5 +99,8 @@
   }
 
-  [PushExpression(StackTypes.Exec, "EXEC.FLUSH")]
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.FLUSH",
+    "Empties the EXEC stack.")]
   [StorableClass]
   public class ExecFlushExpression : FlushExpression<Expression> {
@@ -103,5 +118,8 @@
   }
 
-  [PushExpression(StackTypes.Code, "CODE.FLUSH")]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.FLUSH",
+    "Empties the CODE stack.")]
   [StorableClass]
   public class CodeFlushExpression : FlushExpression<Expression> {
@@ -119,5 +137,8 @@
   }
 
-  [PushExpression(StackTypes.Char, "CHAR.FLUSH")]
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.FLUSH",
+    "Empties the CHAR stack.")]
   [StorableClass]
   public class CharFlushExpression : FlushExpression<char> {
@@ -135,5 +156,8 @@
   }
 
-  [PushExpression(StackTypes.String, "STRING.FLUSH")]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.FLUSH",
+    "Empties the STRING stack.")]
   [StorableClass]
   public class StringFlushExpression : FlushExpression<string> {
@@ -151,5 +175,8 @@
   }
 
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].FLUSH")]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].FLUSH",
+    "Empties the INTEGER[] stack.")]
   [StorableClass]
   public class IntegerVectorFlushExpression : FlushExpression<IReadOnlyList<long>> {
@@ -167,5 +194,8 @@
   }
 
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].FLUSH")]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].FLUSH",
+    "Empties the FLOAT[] stack.")]
   [StorableClass]
   public class FloatVectorFlushExpression : FlushExpression<IReadOnlyList<double>> {
@@ -183,5 +213,8 @@
   }
 
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].FLUSH")]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].FLUSH",
+    "Empties the BOOLEAN[] stack.")]
   [StorableClass]
   public class BooleanVectorFlushExpression : FlushExpression<IReadOnlyList<bool>> {
@@ -199,5 +232,8 @@
   }
 
-  [PushExpression(StackTypes.StringVector, "STRING[].FLUSH")]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].FLUSH",
+    "Empties the STRING[] stack.")]
   [StorableClass]
   public class StringVectorFlushExpression : FlushExpression<IReadOnlyList<string>> {
